package asciidb;

import java.io.*;

public class ColumnDesc implements Serializable {
	
	private int    fieldNumber;
	private String fieldName;
	private String fieldLabel;
	private int    position;
	private int    length;
	private boolean       isNumber;
	private boolean       isKeyFigure;
	
	
	
	public ColumnDesc( int fieldNumber, 
	                   String fieldName,
			   int  position,
			   int      length
	)
	{
		this(  fieldNumber, fieldName, position,length, false, false, fieldName); 
		
	}
	
	
	public ColumnDesc( int fieldNumber, 
	                   String fieldName,
			   int  position,
			   int      length,
			   boolean  isNumber,	
			   boolean  isKeyFigure
	)
	{
		this (  fieldNumber, fieldName, position,length, isNumber, isKeyFigure, fieldName); 
		
	}
	
	
	public ColumnDesc( int      fieldNumber, 
	                   String   fieldName,
			   int      position,
			   int      length,
			   boolean  isNumber,	
			   boolean  isKeyFigure,
			   String   fieldLabel
	)
	{
		this.fieldNumber  = fieldNumber;
		this.fieldName    = fieldName;
		this.position     = position;
		this.length       = length;
		this.isNumber     = isNumber;
		this.isKeyFigure  = isKeyFigure;
		this.fieldLabel   = fieldLabel;
	}
	
	
	public String    getName()     { return fieldName; }
	public int       getPosition() { return position; }
	public int       getLength()   { return length; }
	public boolean   isNumber()    { return isNumber; }
	public boolean   isKeyFigure() { return isKeyFigure; }
	public String    getLabel()     { return fieldLabel; }
	public String    toString()
	{
		return "{ "+
			"fieldNumber="+fieldNumber+", "+
			"fieldName="+fieldName+", "+
			"position="+position+", "+
			"length="+length+", "+
			"isNumber="+isNumber+", "+
			"isKeyFigure="+isKeyFigure+", "+
			"fieldLabel="+fieldLabel+ 
		        " }";
	}

	//public ColumnDesc [] setAll( int fieldNumber, String fieldName, int position, int length, boolean isNumber, boolean isKeyFigure, String fieldLabel )
	//{ 
	//	return fieldName; 
	//}


}

