package asciidb;

import java.io.*;
import java.util.*;
import dbutils.TableReader;

public class TableCol implements TableReader  {
	
	private  BufferedReader cls_in;
	private  String         cls_actRow;
	private  int            cls_actRowCount; 
	private  String         cls_tableName;
	private  ColumnDesc []  cls_columnDescription;
	private  int            cls_colCount; 
	
	
	
	
	public TableCol( ColumnDesc [] columnDescription)
	{
		cls_columnDescription = columnDescription;
		cls_colCount          = cls_columnDescription.length;

	}
	
	// ***********************  open()  ************************************************	
	/**
	
	
	
	*/
	
	public  void open ( String pTable) throws IOException
	{ 
		cls_in = new BufferedReader( new FileReader( pTable )   );
		cls_actRowCount=0;
		cls_tableName=pTable;
	}
	// ***********************  close()  ************************************************	
	/**
	
	
	
	*/
	public void close () throws IOException
	{
		cls_in.close(); 
	}
	// ***********************  getColumnCount()  ************************************************	
	/**
	Gibt die Anzahl der Spalten zurck;
	*/
	public int getColumnCount()
	{ 	
		return cls_colCount;
	}
	
	
	// ***********************  getColumnName()  ************************************************	
	/**
	
	Name der Spalte.
	
	@param  columnIndex  Spaltennummer beginnend mit 1
	
	
	*/  
	public String getColumnName( int columnIndex)
	{
		return trimString(cls_columnDescription [columnIndex-1].getName());
		
	}
	
	// *********************** getColumnLabel    *************************************************************	
	/**
	
	Spaltenueberschrift; falls nicht definiert sollte hier der Name der Spalte zurckgegeben werden.
	
	@param  col  Spaltennummer beginnend mit 1
	
	
	*/   
	
	public String getColumnLabel( int columnIndex)
	{
		return trimString(cls_columnDescription [columnIndex-1].getLabel());
		
	}	
	
	// ***********************  getCellDisplaySize()  ************************************************	
	/**
	Bezogen auf die aktuelle Zeile, wird die Lnge des aktuelle Wertes der Spalte (Zelle), als String formatiert,  bestimmt
	
	@param  columnIndex   Spaltenindex; erste Spalte ist 1
	*/
	public int getCellDisplaySize(int columnIndex)
	{ 	
		//return cls_columnDescription [columnIndex-1].getLength();
		String feld=getString( columnIndex);
		return feld.length();
	}
	// ***********************  getString()  ************************************************
	/**
	
	String-Wert der Spalte bezogen auf die aktuelle Zeile, also nach next().
	
	@param  col  Spaltennummer beginnend mit 1
	
	*/  
	public String getString( int columnIndex)
	{
		int von   = cls_columnDescription [columnIndex-1].getPosition()-1;
		int bis   = von + cls_columnDescription [columnIndex-1].getLength();
		
		//if ( columnIndex  > cls_colCount ||  columnIndex  < 1) return (String) null;
		return trimString(cls_actRow.substring(von,bis));
		
	}
	
	// *********************** getDouble    *************************************************************	
	/**
	
	Double-Wert der Spalte bezogen auf die aktuelle Zeile, also nach next().
	
	@param  col  Spaltennummer beginnend mit 1
	
	
	*/  
	public double getDouble( int columnIndex)
	{
		double result;
		
		String sValue=getString(columnIndex);
		char firstChar=sValue.charAt(0);
		
		if ( firstChar == ' ' || firstChar == '.') 
			result=(double) 0;
		else
			result= Double.parseDouble(sValue);
		
		return result;
		
	}
	
	
	
	
	// ***********************  next()  ************************************************	
	/**
	
	
	
	*/
	
	public  boolean  next()  
	{  
		try {
		boolean result=true;
		cls_actRow=null; 
		
		if (( cls_actRow = cls_in.readLine()) != null) 
		{ result=true;
			cls_actRowCount++;	
		}	
		else result=false;
		
		return result;	
		 
		} catch (Exception e) 
		{  
			System.out.println("LESEFEHLER in Zeile "+cls_actRowCount);
			//throw e;
			return false;
		}
	}
	// *********************** isKeyFigure  ************************************************	
	/**
	
	
	
	*/
	
	public boolean isKeyFigure (int columnIndex)
	{
		
		return  cls_columnDescription [columnIndex-1].isKeyFigure();
		
	}
	// *********************** isNumber    *************************************************************	
	/**
	Gibt an, ob diese Spalte numerisch ist.
	
	Z.B. ist eine Spalte MONAT i.d.R. numerisch aber keine Kennzahl.
	
	@param  columnIndex  Spaltennummer beginnend mit 1
	
	*/  
	
	public boolean isNumber (int columnIndex)
	{ 
		return  cls_columnDescription [columnIndex-1].isNumber();
		
	}		
	
	public int getRowNumber()
	{
		return cls_actRowCount;	 
	}
	
	// ----------------------------------------------------------------------------------------------
	// PRIVATE Funktionen
	// ----------------------------------------------------------------------------------------------
	// *************************** trimString ********************************** 
	
	/**
	Leerzeichen werden entfernt; Null-Strings mit Leerzeichen belegt
	
	
	@return  String 
	
	
	*/
	
	private String  trimString(String s) 
	{
		String value=s;
		if (value == null) value=" ";
		else
		{
			value=value.trim();
			if (value.length()==0) value=" ";
		}
		
		
		return value;
		
		
	}  // end method
	
	
	
}
