package dbutils;




import java.util.*;
import java.io.*;

// ==================================================
// Klasse RamSchema
// ==================================================
public class RamSchema  implements Serializable {
	
	private Map Tables;
	private Map Lookup;
	
	// ------------------------------------------------------
	// Konstruktor
	// ------------------------------------------------------
	
	public  RamSchema() {
		
		Tables        = new TreeMap();
		Lookup        = new TreeMap();
	} // End method
	
	// ------------------------------------------------------
	// "Normale"-Tabellen
	// ------------------------------------------------------
	private boolean removeTable(String alias)
	{
		Tables.remove(alias);
		return true;
	} // End method
	
	public  boolean addTable(String alias, RamTable table)
	{
		
		Tables.put(alias,table) ;
		return true;
	} // End method
	
	public RamTable getTable(String alias)
	{
		return (RamTable) Tables.get(alias);
	} // End method
	
	// ------------------------------------------------------
	// Lookup-Tabellen
	// ------------------------------------------------------
	public  boolean addLookup(String alias, SortedMap table)
	{
		
		Lookup.put(alias,table) ;
		return true;
	} // End method
	
	public SortedMap getLookup(String alias)
	{
		return (SortedMap) Lookup.get(alias);
	} // End method
	
	private boolean removeLookup(String alias)
	{
		Lookup.remove(alias);
		return true;
	} // End method
	
	public String toString()
	{
		return ("LOOKUP="+Lookup.toString()+"  RAM-TABLES="+Tables.toString()); 
		
		
	}
	
	
} // End class
