package dbutils;

import java.util.*;

public class RamTableReader implements TableReader  {

        private RamTable        cls_rt;
	private  int            cls_colCount; 
	private String []       cls_ColumnNames;
	private String []       cls_ColumnLabels;
        private int             cls_actRowNr;	
	private int             cls_nrOfRows;
        String []               cls_actRow;	


	public RamTableReader( RamTable rt)
	{
		cls_rt           = rt;
                cls_ColumnNames  = rt.getColumnNames();
                cls_ColumnLabels = rt.getColumnNames();
		cls_colCount     = cls_ColumnNames.length;
		cls_actRowNr     = -1;
		cls_nrOfRows     = rt.size();
		cls_actRow       = null;
	}



	// ***********************  getColumnCount()  ************************************************	
	/**
	Gibt die Anzahl der Spalten zurck;
	*/
	public int getColumnCount()
	{ 	
		return cls_colCount;
	}
	
	// ***********************  getColumnName()  ************************************************	
	/**
	
	Name der Spalte.
	
	@param  columnIndex  Spaltennummer beginnend mit 1
	
	
	*/  
	public String getColumnName( int columnIndex)
	{
		return cls_ColumnNames [columnIndex-1];
		
	}
	
	// *********************** getColumnLabel    *************************************************************	
	/**
	
	Spaltenueberschrift; falls nicht definiert sollte hier der Name der Spalte zurckgegeben werden.
	
	@param  col  Spaltennummer beginnend mit 1
	
	
	*/   
	
	public String getColumnLabel( int columnIndex)
	{
		return cls_ColumnLabels [columnIndex-1];
	}	
	
	
	// ***********************  getCellDisplaySize()  ************************************************	
	/**
	Bezogen auf die aktuelle Zeile, wird die Lnge des aktuelle Wertes der Spalte (Zelle), als String formatiert,  bestimmt
	
	@param  columnIndex   Spaltenindex; erste Spalte ist 1
	*/
	public int getCellDisplaySize(int columnIndex)
	{ 	
		return cls_actRow[columnIndex-1].length();
		
	}

	// ***********************  next()  ************************************************	
	/**
	
	
	
	*/
	
	public  boolean  next()  
	{  
		cls_actRowNr++;
		boolean nochZeilen=cls_actRowNr<cls_nrOfRows;
		
		if ( nochZeilen )
		{
			cls_actRow=cls_rt.getRow(cls_actRowNr);
		}
		else
		{
			cls_actRow=null;
			
		}
		
		return nochZeilen;

	}
	
		// *********************** isKeyFigure  ************************************************	
	/**
	
	
	
	*/
	
	public boolean isKeyFigure (int columnIndex)
	{
		
		return  false;
		
	}
	// *********************** isNumber    *************************************************************	
	/**
	Gibt an, ob diese Spalte numerisch ist.
	
	Z.B. ist eine Spalte MONAT i.d.R. numerisch aber keine Kennzahl.
	
	@param  columnIndex  Spaltennummer beginnend mit 1
	
	*/  
	
	public boolean isNumber (int columnIndex)
	{ 
		return  false;
		
	}		
	
	public int getRowNumber()
	{
		return cls_actRowNr+1;	 
	}
	
	// ***********************  getString()  ************************************************
	/**
	
	String-Wert der Spalte bezogen auf die aktuelle Zeile, also nach next().
	
	@param  col  Spaltennummer beginnend mit 1
	
	*/  
	public String getString( int columnIndex)
	{
		return cls_actRow[columnIndex-1];
	}
	
	// *********************** getDouble    *************************************************************	
	/**
	
	Double-Wert der Spalte bezogen auf die aktuelle Zeile, also nach next().
	
	@param  col  Spaltennummer beginnend mit 1
	
	
	*/  
	public double getDouble( int columnIndex)
	{
		double result;
		
		String sValue=trimString(getString(columnIndex));
		char firstChar=sValue.charAt(0);
		
		if ( firstChar == ' ' || firstChar == '.') 
			result=(double) 0;
		else
			result= Double.parseDouble(sValue);
		
		return result;
		
	}
	
	// ----------------------------------------------------------------------------------------------
	// PRIVATE Funktionen
	// ----------------------------------------------------------------------------------------------
	// *************************** trimString ********************************** 
	
	/**
	Leerzeichen werden entfernt; Null-Strings mit Leerzeichen belegt
	
	
	@return  String 
	
	
	*/
	
	private String  trimString(String s) 
	{
		String value=s;
		if (value == null) value=" ";
		else
		{
			value=value.trim();
			if (value.length()==0) value=" ";
		}
		
		
		return value;
		
		
	}  // end method
	



}
