package dbutils;

/*
 * SortFilterModel.java
 *
 * Created on 13. Februar 2002, 10:43
 */

/**
 *
 * @author  seher
 * @version
 */
import javax.swing.table.*;
import java.util.*;

public class SortFilterModel extends javax.swing.table.AbstractTableModel {
    private TableModel model;
    private int sortColumn;
    private Row[] rows;
    //!! Noch zu loesen: mehrere Spalten sortieren; auf und absteigend sortieren

    public SortFilterModel(TableModel m) {
        model = m;
        rows = new Row[model.getRowCount()];
        for ( int i = 0; i < rows.length; i++) {
            rows[i] = new Row();
            rows[i].index = i;
        }

    }

    public void sort(int c) {
        sortColumn=c;
        Arrays.sort(rows);
        fireTableDataChanged();
    }
    // Berechnen der verschobenen Zeilen fuer die drei Methoden,
    // die auf Modelebene zugreifen
    public Object getValueAt(int r, int c) {
        return model.getValueAt(rows[r].index, c);
    }

    public boolean isCellEditable(int r, int c) {
        return model.isCellEditable(rows[r].index, c);
    }

    public void setValueAt(Object aValue, int r, int c) {
        model.setValueAt(aValue, rows[r].index, c);
    }

    // Alle uebrigen Methoden an das Modell delegieren

    public int     getRowCount()        { return model.getRowCount();       }
    public int     getColumnCount()     { return model.getColumnCount();    }
    public String  getColumnName(int c) { return model.getColumnName(c);    }
    public Class   getColumnClass(int c){ return model.getColumnClass(c);    }

    //  *** private class Row
    //  Diese innere Klasse nimmt den Index der Modelzeile auf.
    //  Zeilen werden verglichen, indem die Eintraege der Modelzeilen
    //  in der Sortierspalte betrachtet werden.
    private class Row implements Comparable {
        public int index;
        public int compareTo(Object other) {
            Row otherRow=(Row) other;
            Object a = model.getValueAt(index,sortColumn);
            Object b = model.getValueAt(otherRow.index,sortColumn);

            if ( a instanceof Comparable)
                return ((Comparable)a).compareTo(b);
            else
            {   Class type = model.getColumnClass(sortColumn);
                if (type==Boolean.class) {
                    boolean b1 = ((Boolean) a).booleanValue();

                    boolean b2 = ((Boolean) b).booleanValue();
                    if (b1 == b2) {
                        return 0;
                    }
                    else if  (b1) {
                        return 1;
                    }
                    else return -1;
                }
                System.out.println("Objekt a ist keine Instanz von Comparable");
                return index - otherRow.index;

            }

        }


    } // End class Row

}
