package dbutils;


/** *************************************************************************************
*         Interface TableReader
*  @author   P. Seher
*  @version  1    5.2004  
*
*/



public interface TableReader
{
	
	// *********************** getColumnCount    *************************************************************	
	/**
	
	Anzahl der Spalten
	
	
	*/
	public    int  getColumnCount(); 
	
	// *********************** getColumnLabel    *************************************************************	
	/**
	
	Spaltenueberschrift; falls nicht definiert sollte hier der Name der Spalte zurckgegeben werden.
	
	@param  col  Spaltennummer beginnend mit 1
	
	
	*/  
	public String  getColumnLabel(int col);
	
	// *********************** getColumnName    *************************************************************	
	/**
	
	Name der Spalte.
	
	@param  col  Spaltennummer beginnend mit 1
	
	
	*/  
	public String getColumnName( int col);
	
	// *********************** isKeyFigure    *************************************************************	
	/**
	
	Ist diese Spalte eine Kennzahl? Wenn ja, mu sie in jedem Fall numerisch sein.
	
	Z.B. ist eine Spalte MONAT i.d.R. numerisch aber keine Kennzahl.
	
	@param  col  Spaltennummer beginnend mit 1
	
	*/  
	public boolean isKeyFigure (int col);   
	
	// *********************** isNumber    *************************************************************	
	/**
	
	Ist diese Spalte eine numerisch ?   .
	
	Z.B. ist eine Spalte MONAT i.d.R. numerisch aber keine Kennzahl.
	
	@param  col  Spaltennummer beginnend mit 1
	
	*/  
	
	public boolean isNumber(int col);
	
 	// *********************** next()    *************************************************************	
	/**
	
	Es wird auf den nchsten Satz positioniert. 
	
	*/  
	public boolean next();
	
	// *********************** getDouble    *************************************************************	
	/**
	
	Double-Wert der Spalte bezogen auf die aktuelle Zeile, also nach next().
	
	@param  col  Spaltennummer beginnend mit 1
	
	
	*/  
	public double  getDouble(int col);
	
	// *********************** getString    *************************************************************	
	/**
	
	String-Wert der Spalte bezogen auf die aktuelle Zeile, also nach next().
	
	@param  col  Spaltennummer beginnend mit 1
	
	*/  
	public String  getString(int col);
	
	// ***********************  getCellDisplaySize()  ************************************************	
	/**
	Bezogen auf die aktuelle Zeile, wird die Lnge des aktuelle Wertes der Spalte (Zelle), als String formatiert,  bestimmt
	
	@param  columnIndex   Spaltenindex; erste Spalte ist 1
	*/
	public int  getCellDisplaySize(int col);
	
	// *********************** getRowNumber  ************************************************	
	/**
	
	Aktuelle Zeilennummer
	
	
	*/  
	public int getRowNumber();	
	
	
	
	
	
}
