package mobile;


import dbutils.*;
import asciidb.*;
import mysystem.*;

import excel.*;
import java.util.*;
import java.text.*;
import java.net.*;
import java.io.*;



public abstract class Export{
	
	public static int FEHLER_INITIALISIERUNG   =  110;
	public static int FEHLER_VERARBEITUNG      =  112;
	
	// ======================= createExcelFiles() ======================================================
	public int createExcelFiles( String pPersnr, RamTable  rtExcel )
	{
		
		int         ergebnis = FEHLER_VERARBEITUNG;
		
		
		try {
			
			// -- Verzeichnis fuer alle Excel-Dateien einer Persnr. erzeugen: D<persnr>
			
			File zielVerzeichnisExcelPersnr  = new File (getPathExcelReports(pPersnr) );
			
			if ( zielVerzeichnisExcelPersnr.exists()) OS.rmDirectory( zielVerzeichnisExcelPersnr.getAbsolutePath());
			zielVerzeichnisExcelPersnr.mkdir();
			
			
			// -- Stoppuhren auf 0 stellen
			Clock zeit       = new Clock();
			
			// -- Indizes fr Feldnamen bestimmen
			int idxId                =  rtExcel.getColumnIndex("ID");
			int idxExcelFileName     =  rtExcel.getColumnIndex("EXCEL_DATEI");
			int idxSheetHeader       =  rtExcel.getColumnIndex("EXCEL_HEADER_NAME");
			int idxSheetName         =  rtExcel.getColumnIndex("EXCEL_SHEET_NAME");
			int idxRangeName         =  rtExcel.getColumnIndex("EXCEL_RANGE_NAME");
			int idxExcelTemplateName =  rtExcel.getColumnIndex("EXCEL_VORLAGE");
			
			for ( int i=0; i<rtExcel.size();i++) 	 
			{
				zeit.start();
				String [] zeile = rtExcel.getRow(i);
				
				String id                   =  zeile[ idxId ];
				String excelFileName        =  getPathExcelReport(zeile[ idxExcelFileName ], pPersnr);
				String excelTemplate        =  getPathTemplate(zeile [idxExcelTemplateName]) ;
				
				
				String asciiFileName = getPathData( id, pPersnr); // Vertreterdaten als ASCII-Datei
				
				// --- EXCEL-Workbook mit Vorlage erzeugen
				excel.Workbook wb = new excel.Workbook();
				// .. bei einem open-Fehler wird ein Null-Objekt zurckgegeben
				//    ueber Null-Pointer erfolgt ein sofortiger Abbruch der Verarbeitung 
				
				
				wb.open( excelFileName,excelTemplate) ;
				// --- EXCEL-Sheet erzeugen
				excel.Sheet sheetData = wb.createSheet(	zeile[ idxSheetName ] );
				
				// -- Header und Range fr Sheet erzeugen
				sheetData.setHeader(zeile[ idxSheetHeader ]);
				sheetData.setRangeName(zeile[ idxRangeName ]);
				
				// -- TableReader fr ASCII-Datei kreieren
				TableCol tc = new TableCol(getLtColDesc(id) );
				tc.open( asciiFileName);
				
				// -- EXCEL-Sheet ber den TableReader fllen			 
				sheetData.importTable( (TableReader) tc );
				
				tc.close();
				
				wb.write(); // Workboolk als Datei schreiben
				
				wb.close();
				
				
				
				zeit.stop();
				System.out.println( ">>> Benoetigte Zeit:"+id+" ("+pPersnr+"): "+zeit.getTimeInSeconds()+" sek");
				ergebnis=0;
				
			}
			
			//System.out.println( ">>> =============================================================================");
			
			
		} catch (Exception e) 
		{
			e.printStackTrace(System.err); 
			System.out.println("<<< Fehler beim Schreiben der Excel-Dateien >>>");
			ergebnis = FEHLER_VERARBEITUNG;		 
		} 
		
		return ergebnis;
		
		
	} // End Method
	
	
	public abstract String getPathExcelReports(String pPersnr);
	
	
	public abstract String getPathExcelReport(String excelFileName , String pPersnr);
	
	
	public abstract String getPathTemplate(String excelTemplateName);
	
	
	public abstract String getPathData( String id, String pPersnr);
	
	public  abstract ColumnDesc [] getLtColDesc(String id);
	
}
