package mobile;


import dbutils.*;
import asciidb.*;
import mysystem.*;

import excel.*;
import java.util.*;
import java.text.*;
import java.net.*;
import java.io.*;



public class PreStepDay  {
	
	static        mobile.MGlobal cls_global;
	static        mobile.Schema  cls_schema;
	static        String sheetNameDatenstand="daten";
	
	static        String   cls_DatenstandMonat;
	static        String   cls_BM;
	static        String   cls_BJ;
	static        String   cls_VJ;



	
	public static void main (String[] args)  
	{
		
		int ergebnis = 1;   
		
		Clock zeitGesamt = new Clock();
		zeitGesamt.start();
		
		if (init())
		{
			PreStepDay t = new PreStepDay();			
			if ( t.createExcelIndexFile()) ergebnis = 0;
			
		}
		
		zeitGesamt.stop();
		System.out.println( ">>>  Benoetigte Zeit PreStepDay :"+zeitGesamt.getTimeInSeconds()+" sek"); 
		if ( ergebnis ==0 ) System.out.println (">>> --- Alles O.K. ----");
		else                System.out.println (">>> --- Lauf mit FEHLER (RC:"+ergebnis+") beendet  ---");
			
		System.exit(ergebnis); 
		
	} // End main


	public boolean createExcelIndexFile()
	{
		
		boolean ergebnis=true;
		
		try {
			
			SimpleDateFormat dateFormat = new SimpleDateFormat ("dd.MM.yy");
			
		        String [] [] datenStatus     =  {
			                                  { dateFormat.format(new java.util.Date()), "Datenstand Tageslauf" },
		                                          { cls_DatenstandMonat,  "Datenstand Monatslauf"},
		                                          { cls_BM, "Berichtsmonat des Monatslaufes"},
			                                  { cls_BJ, "Berichtsjahr"},
			                                  { cls_VJ, "Vorjahr"} 
			                                };
			
			
			String excelTemplate =  cls_global.getPathTemplate("index.xls") ;
			String excelFileName =  cls_global.getPathExcelReportsDaily()+"/index.xls";
			// --- EXCEL-Workbook mit Vorlage erzeugen
			excel.Workbook wb = new excel.Workbook();
			// .. bei einem open-Fehler wird ein Null-Objekt zurckgegeben
			//    ueber Null-Pointer erfolgt ein sofortiger Abbruch der Verarbeitung 
			
			
			wb.open( excelFileName,excelTemplate) ;
			// --- EXCEL-Sheet erzeugen
			
			//if (wb.existsSheet(sheetNameDatenstand)) wb.removeSheet( sheetNameDatenstand);
			//excel.Sheet sheetData = wb.createSheet(	sheetNameDatenstand );
			
			excel.Sheet sheetData = wb.getSheet(	sheetNameDatenstand );
			

                        for (short i=0; i < datenStatus.length; i++)
			{
			         sheetData.createRow(i,  datenStatus[i] );
			}
			 
			
			wb.write(); // Workboolk als Datei schreiben
				
			wb.close();			
			
			
		} catch (Exception e) 
		{
			e.printStackTrace(System.err); 
			System.out.println("<<< Fehler beim Schreiben der Excel-Dateien >>>");
			ergebnis = false;	 
		} 
		
		return ergebnis;
	}
	
	

	private static boolean init()
	{ 
		boolean         ergebnis            = false;
		FileInputStream isMonthlyProperties  = null;
		String           propertyFile;
		
		try {
			
			cls_global   = new mobile.MGlobal();
			cls_schema   = cls_global.getSchema();
			
			try {
				propertyFile=cls_global.getPathExcelReportsMonthly()+"/status.properties";
				
				java.util.Properties properties = MyIo.readProperties(propertyFile);
				
				cls_DatenstandMonat = properties.getProperty("START_DATE");
				cls_BM              = properties.getProperty("BM");
				cls_BJ              = properties.getProperty("BJ");
				cls_VJ              = properties.getProperty("VJ");
				
			} catch (Exception e) 
			{
				e.printStackTrace(System.err); 
				System.out.println("<<< Monatsdatei nicht vorhanden oder fehlerhaft >>>");
				
				// In jedem Fall werden die Werte belegt
				
				cls_DatenstandMonat = "-";
				cls_BM              = "-";
				cls_BJ              = "-";
				cls_VJ              = "-";
				ergebnis=true;
			} 		
			
			
			ergebnis     = true;
			
		} catch (Exception e) 
		{
			e.printStackTrace(System.err); 
			System.out.println("<<< FEHLER beim Initialisieren des Programms >>>");
			ergebnis=false;
		} 
		
		return ergebnis;
	}


} // End Class


