package mobile;

import java.io.*;
import java.util.*;
import asciidb.*;
import dbutils.*;
import excel.*;

public class ViewMeta {
	

	static        mobile.Schema  cls_schema;
	static        mobile.MGlobal cls_global;

	
	public static void main (String[] args)   
	{
		
		try {
                        
		  cls_global     = new mobile.MGlobal();
			cls_schema     = cls_global.getSchema();
			
			String excelFileName =args[0];	
			excel.Workbook wb = new excel.Workbook();
	    wb.open( excelFileName) ;

			RamTable rtTag = cls_schema.getOrderDaily();
			excel.Sheet sheetTag = wb.createSheet("OrderDaily");			 
			sheetTag.importTable(  new RamTableReader(rtTag) );
			
			RamTable rtMonat = cls_schema.getOrderMonthly();
			excel.Sheet sheetMonat = wb.createSheet("OrderMonthly");			 
			sheetMonat.importTable(  new RamTableReader(rtMonat) );
			
			TreeSet idSet = new TreeSet ( rtTag.getColumnSet("ID") );
			idSet.addAll( rtMonat.getColumnSet("ID") );
			
			
			Iterator e = idSet.iterator();
			
			while (e.hasNext())
			{
				
				String   id   = (String) e.next();
				
				//System.out.println("id: "+id);
				RamTable   rtCol=new RamTable(id);
				ColumnDesc []   colDesc  = cls_schema.getColDesc(id);
				
				String [] colNames = {"Name",
					"Position",
					"Length",
					"isNumber",
					"isKeyFigure",
					"Label"
				};
				rtCol.addColumnNames(colNames);


				for (int i=0; i<colDesc.length; i++)
				{
					String [] colZeile = 
					{
			      colDesc[i].getName(),
						Integer.toString( colDesc[i].getPosition() ),
						Integer.toString(colDesc[i].getLength() ),
						Boolean.toString( colDesc[i].isNumber() ),
						Boolean.toString( colDesc[i].isKeyFigure()),
						colDesc[i].getLabel() ,
					};
					
					rtCol.addRow(colZeile);
				}
			excel.Sheet sheetCol = wb.createSheet(id+"_ColDesc");			 
			sheetCol.importTable(  new RamTableReader(rtCol) );				
				
			}
			
      RamTable   rtInfo=new RamTable("VERSION");
			String [] iKopf={"INFO"};
			rtInfo.addColumnNames(iKopf);
			String [] iZeile={ cls_schema.getInfoMap().toString() };
			rtInfo.addRow(iZeile);
			excel.Sheet sheetCol = wb.createSheet("Info");
			sheetCol.importTable(  new RamTableReader(rtInfo) );
			
      wb.write(); // Workboolk als Datei schreiben				
      wb.close();

      System.out.println ("Excel-Sicht der Schema-Datei wurde unter \n\t '"+excelFileName+"'\n erfolgreich erstellt");			
			
		} catch (Exception e) {
			e.printStackTrace(System.err); 
		}
		
	} // End main
	

}


