package mysystem;

/** *************************************************************************************
<p>   
  Einfache Klasse zur Zeitmessung
  
 </p>
<pre> 
  Clock zeit = new Clock();
  zeit.start();
  
  ....
  
  zeit.stop();
  System.out.println( " Benoetigte Zeit:"+zeit.getTimeInSeconds()+" sek"); 
  
 </pre> 


*
*  @author   P. Seher
*  @version  1.0 05.2004
*
*/
public class Clock {
	
	long startTime;
	long endTime;
	boolean running=false;
	
	public Clock() {}
	// *********************** start    *****************************************	
	/**
	
	Zeitmessung wird gestartet	
	*/   		
	public void start() 
	{
		startTime = System.currentTimeMillis();	
		running   = true;
	}
	// *********************** stop    *****************************************	
	/**
	
	Zeitmessung wird beendet	
	*/   			
	public void stop() 
	{
		endTime  = System.currentTimeMillis();	
		running  = true;
	}
	// *********************** getTime    *****************************************	
	/**
	
	Anzahl der Millisekunden zwischen start() und stop().
	
	*/   	
	
	public long getTime()
	{
		return endTime-startTime;	
	}
	
	// *********************** getTimeInSeconds    *****************************************	
	/**
	
	Anzahl der Sekunden zwischen start() und stop().
	
	*/   	
	public double getTimeInSeconds()
	{
		return (endTime-startTime)/1000.0;	
	}	
	
}
