package mysystem;

import java.io.*;

/** *************************************************************************************
<p>   
Zugriffe aufs Betriebssystem
</p>

*
*  @author   P. Seher
*  @version  1.0 05.2004
*
*/

public  class OS


{
	// *********************** rmDirectory    *****************************************	
	/**
	<p>
	Verzeichnis unbedingt lschen.
	</p>
	<p>
	Hier wird ein Ausflug auf die Systemebene gemacht, weil die entsprechenden Standard-Java-Methoden
	nur leere Verzeichnisse loeschen.
	</p>
	
	*/  	
	public static boolean rmDirectory ( String pDirectory)
	{
		
		// 
		
		String [] myCmd={"rm","-r",pDirectory};
		int rc = cmd( myCmd );
		
		return (rc == 0);
		
	}
	
	// *********************** getEnv    *****************************************	
	/**
	
	Inhalt einer Umgebungsvariablen lesen. Wenn die Variable nicht vorhanden
	ist, ist das Ergebnis (String)  null.
	
	Entspricht dem Aufruf getEnv(<varname>, null);
	
	<pre>
	
	String myHome  = OS.getEnv("HOME");
	</pre>
	
	@param  key  Name der Umbebungsvariablen
	
	
	*/   		
	
	
	public static String getEnv( String key)
	{		
		return getEnv(  key, (String) null);
	}// end getEnv
	
	// *********************** getEnv    *****************************************	
	/**
	
	Inhalt einer Umgebungsvariablen lesen. Wenn die Variable nicht vorhanden
	ist, ist das Ergebnis (String)  null.
	
	Entspricht dem Aufruf getEnv(<varname>, null);
	
	<pre>
	
	String myHome  = OS.getEnv("HOME");
	</pre>
	
	@param  key  	    Name der Umbebungsvariablen
	@param  envDefault  Falls 'key' nicht vorhanden, wird 'envDefault' zurckgegeben.
	
	
	*/   			
	public static String getEnv( String key, String envDefault)
	{
		Process p;
		
		try {
			
			p = Runtime.getRuntime().exec("env");
			//  fuer Windows exec("cmd.exe /c set") bzw. exec("command.com /c set")
			BufferedReader reader = new BufferedReader (new InputStreamReader(p.getInputStream()));
			String zeile;
			while ((zeile = reader.readLine()) != null)
				if (zeile.startsWith(key + "=")) return zeile.substring(key.length() + 1);
		}
		catch (Exception e) { System.out.println ( "FEHLER:"+e.toString()  );}
		
		return envDefault;
	}// end getEnv
	// *********************** CreateOrReplaceDirectory    *****************************************	
	/**
	
	Ein Verzeichnis wird erstellt oder ersetzt, falls vorhanden. Letzteres hat zur Folge,
	da der gesamte Inhalt auch gelscht wird.
	

	@param  pathDirectory  Absoluter Pfad des Verzeichnises
	

	*/   	
	
	public static void  CreateOrReplaceDirectory( String pathDirectory) throws IOException
	{
		
			
		File dir  = new File (pathDirectory );
			
		if ( dir.exists()) OS.rmDirectory( dir.getAbsolutePath());
		if (! dir.mkdir() ) throw new IOException( "Verzeichnis "+pathDirectory+" kann nicht erzeugt werden");
				
		
	} // end CreateOrReplaceDirectory
	
		
	// ---------------------------------------------------------------------
	// PRIVATE Methoden
	// ---------------------------------------------------------------------	
	// Erstmal versuchen alle notwendigen Zugriffe aufs Betriebsystem in Form von Methoden
	//  zwecks Portierbarkeit und Kontrolle einzuschalen. Deswegen ist cmd 'private'
	private static int  cmd (String [] commandArray)
	{
		int myExitValue	= 99;	
		Runtime system = Runtime.getRuntime();
		
		
		try {
			
			
			Process p = system.exec(commandArray);
			BufferedReader reader    = new BufferedReader(
			new InputStreamReader(p.getInputStream())   
			);
			String zeile;
			
			while (( zeile=reader.readLine()) != null) {
				System.out.println(zeile) ;   
			}
			
			
			myExitValue=p.waitFor();
			
			
		}
		catch (Exception e) { System.out.println ( "FEHLER:"+e.toString()  );
		} 
		
		return myExitValue;
		
	} // end cmd
	
	
	
}
