#! /bin/ksh

# =============================================================================
#
#  PROZEDUR  : monat_datamart_mobile_step_persnr.sh
#
#  ZWECK     : Erzeugen der Mobile-Dateien fr eine Untermenge von
#              Personalnummern. Diese Untermenge, gebildet ber Restklassen,
#              wird in Abhngigkeit vom eingestellten Parallelisierungsgrad
#              bestimmt.
#
#  AUFRUF    : monat_datamart_mobile_step_persnr.sh <PERSNR> 
#
#  BEMERKUNG :
#
#  AUTOR     : P. Seher, Cl. Kraus
#
# =============================================================================


USAGE="USAGE: $0 <PERSNR> "


# -----------------------------------------------------------------------------
# Prfen der Eingabe
# -----------------------------------------------------------------------------

[ $# = 1 ]||     { echo Ungltige Parameterzahl; echo $USAGE; exit 1; }
PERSNR=$1;                                       export PERSNR;
echo PERSNR:$PERSNR

# -----------------------------------------------------------------------------
# Initialisierung der STEPSs
# -----------------------------------------------------------------------------


REPORTS=$HOME/mexreports/REPORTS;  export REPORTS;          # Wurzelverzeichnis fr REPORTS

MOBILEPATH=$REPORTS/DATASETS;   export MOBILEPATH;    # Pfad der Datasets

. $REPORTS/setglobal.sh
. $REPORTS/setjava.sh

 DIR_DATA_ASCII=$MOBILEPATH/WORK_DATA_EXPORT/D$PERSNR;   # ASCII-Dateien
 DIR_EXCEL=$MOBILEPATH/MONTHLY/E$PERSNR;                 # EXCEL-Dateien

# -----------------------------------------------------------------------------
# Erstellen der MOBILE-Dateien fr eine Personalnr.
# -----------------------------------------------------------------------------
    
# rm -rf  $DIR_DATA_ASCII;
 rm -rf  $DIR_EXCEL;
   
# mkdir  $DIR_DATA_ASCII ||{ echo "Fehler beim Erzeugen des Verzeichnises $WORK_DATA_EXPORT"; exit 66; }
 mkdir  $DIR_EXCEL ||{ echo "Fehler beim Erzeugen des Verzeichnises $DIR_EXCEL"; exit 66; }
      

 # ---------------------------------
 # -- ASCII-Dateien erstellen 
 # --------------------------------- 

 
 # ---------------------------------
 # --- Daten nach EXCEL exportieren
 # ---------------------------------
 $JAVA mobile.ExportMonthly $PERSNR 2>&1   1>>$LOGPATH/L3_$PERSNR.log
      if [ $? -ne 0 ]
      then
	  echo '############### Fehler beim Erstellen der Dateien fr PERSNR:'$PERSNR;
	  exit 1
       fi   
       
 # ---------------------------------
 # -- ZIP Datei erstellen
 # ---------------------------------        
 cd $DIR_EXCEL||{ echo "Fehler beim Wechseln ins Verzeichnis $DIR_EXCEL"; exit 66; }
 rm -f $MOBILEPATH/MONTHLY/$PERSNR.zip
 $ZIP -r -o $MOBILEPATH/MONTHLY/$PERSNR * 2>&1 >/dev/null || { echo "Fehler beim ZIPPEN bei PERSNR: $PERSNR"; exit 77; }
       
 cd $MOBILEPATH;
 # ---------------------------------
 # -- Aufraeumen
 # ---------------------------------       
# rm -rf  $DIR_DATA_ASCII;
 rm -rf  $DIR_EXCEL;
 rm -f   $LOGPATH/L*_$PERSNR.log   # - Bei erfolgreichem Lauf, Logging-Datei lschen
 
# --- Alles O.K.
exit 0

