#!/bin/ksh

my_usage() {
cat<<end_cat
# ===========================================================================
#
# PROZEDUR:  $0
#
# ZWECK   :  Uebersetzen der Java-Paketen oder Java-Dateien 
#
# AUFRUF  :  `basename $0`  < package|-f datei.java >
#
# AUTOR   :  P. Seher 03/2003
#
# =========================================================================== 
end_cat
}
#set -x
WAS=$1 
#JAVA_HOME=/usr/j2sdk1.4.2_05;                                    export JAVA_HOME;
JAVA_HOME=/usr/lib/j2sdk1.4.1_02
MY_JAVA_HOME=$HOME/mexreports/JAVA                                   export MY_JAVA_HOME;
CLASSES_DE=$HOME/mexreports/JAVA/CLASSES                             export CLASSES_DE;

MY_CLASSES=$MY_JAVA_HOME/CLASSES;                                export MY_CLASSES;
MY_LIBS=$MY_JAVA_HOME/LIBS;                                      export MY_LIBS;

# --------------------------------------------------------------
# CLASSPATH festlegen
# --------------------------------------------------------------

 
CLASSPATH=.:$MY_CLASSES:$CLASSES_DE:$CLASSES_WORLD

for jar in  $MY_LIBS/*/*.jar  $MY_LIBS/*.jar  $JAVA_HOME/lib/*.jar  
do
  CLASSPATH=$CLASSPATH:$jar
done

export CLASSPATH;

#echo "CLASSPATH=$CLASSPATH"

JAVAC=$JAVA_HOME/bin/javac;

JAVA_FILE='---';             export JAVA_FILE;

# --------------------------------------------------------------
# Eingabe pruefen und Zielverzeichnis festlegen
# --------------------------------------------------------------

case $WAS in 

      excel)
            PACKAGE_DIR=$MY_CLASSES/excel
            ;;
     mobile)
            PACKAGE_DIR=$CLASSES_DE/mobile
            ;; 
	    
     mysystem)
            PACKAGE_DIR=$MY_CLASSES/mysystem
            ;;    	    
	   
     dbutils)
            PACKAGE_DIR=$MY_CLASSES/dbutils
            ;;
     asciidb)
            PACKAGE_DIR=$MY_CLASSES/asciidb
            ;;	    
      -f|-file)
            PACKAGE_DIR=.
	    JAVA_FILE=$2
            ;;

           *)
              echo "Ungueltiger Parameter im Aufruf $0 $*"  
              echo "Siehe Beschreibung:\n\n" 
              my_usage;
              exit 1
              ;;
esac
     
export PACKAGE_DIR; 

if [ ! -d "$PACKAGE_DIR" ]
then
    echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    echo "Das Verzeichnis "
    echo "   $PACKAGE_DIR "
    echo "existiert nicht!"
    echo "$0 mit FEHLER beendet"
    echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    exit 1
fi




# --------------------------------------------------------------
# Uebersetzen
# --------------------------------------------------------------

COMPILE_RC=0;
if [ "X$JAVA_FILE" = "X---" ]
then 
     # ---- PACKAGE uebersetzen
     cd $PACKAGE_DIR;
     #$JAVAC -deprecation -verbose *.java 
     $JAVAC -deprecation *.java
     COMPILE_RC=$?
else
    cd .
    $JAVAC -deprecation $JAVA_FILE
    COMPILE_RC=$?
    

fi

if [ $COMPILE_RC -eq 0 ]
  then
       echo "\n\n Alles O.K."
  else
       echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
       echo "$0 mit FEHLER beendet"
       echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  fi
  
exit $COMPILE_RC 

